function [G] = mol2matsd(infile)
%
% A script to read mol format file into frigeo structures.
% 

ip=fopen(infile,'rt');
s=fgetl(ip);
n = 0;
check = 0;
nodelabels = uint32([]);
nodepos = [];
edges = uint32([]);

first = 1;
while(ischar(s))
  while first ~= 1 && strcmp(s, '$$$$') == 0
    disp(['line: ', s]);
    disp(['length: ', num2str(length(s))]);
    s=fgetl(ip);
  end
  if first == 0
    s=fgetl(ip);
  end
  first = 0;
  if s == -1
    break
  end

  % First line: molecule name
  molecule_name = s;
  disp(['NEW MOLECULE: ', molecule_name]);

  s=fgetl(ip);
  s=fgetl(ip);
  % Read until seeing a ".$" line
%  while s(end) ~= '.'
%    s=fgetl(ip);
%    disp(['searching for dot: ', s]);
%  end

  disp(['NEW GRAPH']);
%  if strcmp(s,'')
    s=fgetl(ip);

    line = sscanf(s,'%d');
    disp(['s: ', s]);
    num_nodes = line(1);
    num_edges = line(2);
    disp([' number of nodes/edges: ', num2str(num_nodes), ', ', num2str(num_edges)]);
    for i=1:num_nodes
      s=fgetl(ip);
      pos = sscanf(s,'%f');
      nodepos=[nodepos;pos(1:3)'];
      line = sscanf(s,'%c');
      %      atomlabel = line(32);
      if strcmp(line(32),'H')
		if strcmp(line(33),' ')
		  nodelabels = uint32([nodelabels ; uint32(1)]);
		elseif strcmp(line(33),'g')
		  nodelabels = uint32([nodelabels ; uint32(80)]);
		else
		  disp(['Warning! Atom: ',[line(32) line(33)],' was not read. Add the entry!']);
		end
	  elseif strcmp(line(32),'C')
		if strcmp(line(33),' ')
		  nodelabels = uint32([nodelabels ; uint32(6)]);
		elseif strcmp(line(33),'l')
		  nodelabels = uint32([nodelabels ; uint32(17)]);
		elseif strcmp(line(33),'a')
		  nodelabels = uint32([nodelabels ; uint32(20)]);
		elseif strcmp(line(33),'u')
		  nodelabels = uint32([nodelabels ; uint32(29)]);
		else
		  disp(['Warning! Atom: ',[line(32) line(33)],' was not read. Add the entry!']);
		end
	  elseif strcmp(line(32),'N')
		if strcmp(line(33),' ')
		  nodelabels = uint32([nodelabels ; uint32(7)]);
		elseif strcmp(line(33),'a')
		  nodelabels = uint32([nodelabels ; uint32(11)]);
		else
		  disp(['Warning! Atom: ',[line(32) line(33)],' was not read. Add the entry!']);
		end
	  elseif strcmp(line(32),'O')
		if strcmp(line(33),' ')
		  nodelabels = uint32([nodelabels ; uint32(8)]);
		else
		  disp(['Warning! Atom: ',[line(32) line(33)],' was not read. Add the entry!']);
		end
	  elseif strcmp(line(32),'F')
		if strcmp(line(33),' ')
		  nodelabels = uint32([nodelabels ; uint32(9)]);
	    elseif strcmp(line(33),'e')
		  nodelabels = uint32([nodelabels ; uint32(26)]);
		else
		  disp(['Warning! Atom: ',[line(32) line(33)],' was not read. Add the entry!']);
		end
	  elseif strcmp(line(32),'M')
		if strcmp(line(33),'g')
		  nodelabels = uint32([nodelabels ; uint32(12)]);
		elseif strcmp(line(33),'n')
		  nodelabels = uint32([nodelabels ; uint32(25)]);
		else
		  disp(['Warning! Atom: ',[line(32) line(33)],' was not read. Add the entry!']);
		end
	  elseif strcmp(line(32),'A') %
		if strcmp(line(33),'l')
		  nodelabels = uint32([nodelabels ; uint32(13)]);
		else
		  disp(['Warning! Atom: ',[line(32) line(33)],' was not read. Add the entry!']);
		end
	  elseif strcmp(line(32),'P')
		if strcmp(line(33),' ')
		  nodelabels = uint32([nodelabels ; uint32(15)]);
		elseif strcmp(line(33),'b')
		  nodelabels = uint32([nodelabels ; uint32(82)]);
		else
		  disp(['Warning! Atom: ',[line(32) line(33)],' was not read. Add the entry!']);
		end
      elseif strcmp(line(32),'S')
		if strcmp(line(33),' ')
		  nodelabels = uint32([nodelabels ; uint32(16)]);
		elseif strcmp(line(33),'e')
		  nodelabels = uint32([nodelabels ; uint32(34)]);
		elseif strcmp(line(33),'n')
		  nodelabels = uint32([nodelabels ; uint32(50)]);
		elseif strcmp(line(33),'i')
          nodelabels = uint32([nodelabels ; uint32(14)]);
		else
		  disp(['Warning! Atom: ',[line(32) line(33)],' was not read. Add the entry!']);
		end
      elseif strcmp(line(32),'K')
		if strcmp(line(33),' ')
		  nodelabels = uint32([nodelabels ; uint32(19)]);
		else
		  disp(['Warning! Atom: ',[line(32) line(33)],' was not read. Add the entry!']);
		end
      elseif strcmp(line(32),'B')
		if strcmp(line(33),' ')
		  nodelabels = uint32([nodelabels ; uint32(5)]);
		elseif strcmp(line(33),'r')
		  nodelabels = uint32([nodelabels ; uint32(35)]);
		else
		  disp(['Warning! Atom: ',[line(32) line(33)],' was not read. Add the entry!']);
		end
      elseif strcmp(line(32),'Z')
		if strcmp(line(33),'n')
		  nodelabels = uint32([nodelabels ; uint32(30)]);
		else
		  disp(['Warning! Atom: ',[line(32) line(33)],' was not read. Add the entry!']);
		end
      elseif strcmp(line(32),'T')
		if strcmp(line(33),'e')
		  nodelabels = uint32([nodelabels ; uint32(52)]);
		else
		  disp(['Warning! Atom: ',[line(32) line(33)],' was not read. Add the entry!']);
		end
      elseif strcmp(line(32),'I')
		if strcmp(line(33),' ')
		  nodelabels = uint32([nodelabels ; uint32(53)]);
		else
		  disp(['Warning! Atom: ',[line(32) line(33)],' was not read. Add the entry!']);
		end
      else
		disp(['Warning! Atom: ',[line(32) line(33)],' was not read. Add the entry!']);
	    keyboard;
      end
    end
    for i=1:num_edges
      s=fgetl(ip);
      line = sscanf(s,'%d');
      edges = uint32([edges; uint32([line(1) line(2) line(3)])]);
	  disp(['edge from ', num2str(line(1)), ' to ', num2str(line(2)), ...
		' label ', num2str(line(3))]);
    end
    n = n + 1;
    G{n}.molecule_name = molecule_name;
    G{n}.nodelabels = nodelabels;
    G{n}.nodepos = nodepos;
    G{n}.edges = edges;
    nodelabels = uint32([]);
    nodepos=[];
    edges = uint32([]);
%  end
%  disp(['SKIP']);
%  while ischar(s) && strcmp(s,'$$$$')==0
%    disp(['skip: ', s]);
%    s=fgetl(ip);
%  end
%  s=fgetl(ip);
end
    
